zoukankan      html  css  js  c++  java
  • LeetCode 235. Lowest Common Ancestor of a Binary Search Tree (二叉搜索树最近的共同祖先)

    Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

    According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

            _______6______
           /              
        ___2__          ___8__
       /              /      
       0      _4       7       9
             /  
             3   5
    

    For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.


    题目标签:Tree
      这道题目给了我们一个二叉搜索树,和两个点,让我们找到这两个点的最近的共同祖先。什么是最近的共同祖先的呢?来看看题目给的例子,如果给的两个点是3和5, 那么它们的LCA就是4;如果给的是3和9,那么它们的LCA就是6。这道题目我们要根据BST的特性来做,BST的每一个点,它的左边的孩子都比它小,右边的孩子都比它大。
      所以根据上述的这一点,我们每遍历一个点,就来判断一下要继续往左边走,还是往右边走,还是找到了祖先。
      这里有三种情况:(对于每一个遍历点)
        1. 拿p和q之间大的那一个 叫t-max, 和 遍历的点node比较一下,如果t-max 比node val 小的话,说明p和q 都在node 的左边,那么我们要继续走到左边取找;
        2. 拿p和q之间小的那一个,t-min, 和遍历的点node比较一下,如果t-min 比node val 大的话,说明p和q都在node 的右边,那么我们要继续走到右边取找;
        3. 剩下的情况就说明,p和q 在 node 的左右两边,或者是node 是p或者q, 另外一个点在node 的一边。 这种情况就是找到了祖先,把这一个node 返回。
     
     
     

    Java Solution:

    Runtime beats 62.62% 

    完成日期:07/04/2017

    关键词:Tree (BST); LCA (lowest common ancestor)

    关键点:只遍历左边或者右边根据BST的特性

     1 /**
     2  * Definition for a binary tree node.
     3  * public class TreeNode {
     4  *     int val;
     5  *     TreeNode left;
     6  *     TreeNode right;
     7  *     TreeNode(int x) { val = x; }
     8  * }
     9  */
    10 public class Solution 
    11 {
    12     
    13     
    14     public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) 
    15     {
    16        if(root == null)
    17             return null;
    18         
    19         // go into left child if the greater from p and q is smaller than root;
    20         if(Math.max(p.val, q.val) < root.val)
    21             return lowestCommonAncestor(root.left, p, q);
    22         
    23         // go into right child if the smaller from p and q is greater than root;
    24         if(Math.min(p.val, q.val) > root.val)
    25             return lowestCommonAncestor(root.right, p, q);
    26         
    27         // if p and q are not at the left side, and also not at the right side
    28         // meaning p and q are at the both side or root is p or q , another one is at one side.
    29         return root;
    30     }
    31     
    32     
    33 }

    参考资料:

    http://www.cnblogs.com/grandyang/p/4640572.html

    LeetCode 算法题目列表 - LeetCode Algorithms Questions List

  • 相关阅读:
    Blender 3DOne
    [翻译]XNA外文博客文章精选之sixteen(中)
    实习技术员的基本功(二)
    [翻译]XNA外文博客文章精选之fifteen
    实习技术员的基本功(三)
    [翻译]XNA外文博客文章精选之sixteen(下)
    实习技术员的基本功(一)
    [翻译]XNA外文博客文章精选之sixteen(上)
    思维导图
    MySQL error 1045(28000): Access denied for user ...
  • 原文地址:https://www.cnblogs.com/jimmycheng/p/7119249.html
Copyright © 2011-2022 走看看